package gp_dbc.gui.JailManager;

import gp_dbc.Main;
import gp_dbc.system.Cell;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.GL11;

import java.util.List;

import static gp_dbc.utils.DrawGui.drawLimited;

public class GuiJailManager extends GuiScreen {

    final int guiWidth = 212 / 2 + 1;
    final int guiHeight = 320 / 2 + 1;

    private int scroll_y = 0;

    private List<Cell> cells;
    int gap_y = 1;
    int cell_width = 76;
    int cell_height = 10;

    public static int cell_selected = -1; // ID of cell
    private GuiButtonJailManager[] cells_buttons;
    private GuiButtonJailManager delete_cell;
    private GuiButtonJailManager edit_cell;

    public GuiJailManager(List<Cell> cells) {
        this.cells = cells;
        cell_selected = -1;
    }

    @Override
    public void drawScreen(int mouse_x, int mouse_y, float ticks) {

        GL11.glColor4f(1, 1, 1, 1);

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        drawDefaultBackground();

        mc.renderEngine.bindTexture(new ResourceLocation(Main.MODID, "textures/gui/jailManager.png"));

        // Texture
        GL11.glPushMatrix();
        GL11.glEnable(GL11.GL_BLEND);
        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
        //GL11.glColor4d(0.1, 0.6, 0.96, 0.95);
        //GL11.glTranslated(0,0, 1);
        drawTexturedModalRect(guiX, guiY - 10, 0, 0, guiWidth, guiHeight);
        GL11.glPopMatrix();

        int displayWidth = mc.displayWidth;
        int displayHeight = mc.displayHeight;

        int ratioWidth = (int) Math.round((double)displayWidth / width);
        int ratioHeight = (int) Math.round((double)displayHeight / height);

        int newWidth = guiWidth * ratioWidth;
        int newHeight = guiHeight * ratioHeight;

        int displayGuiX = (int)Math.round((double)(displayWidth - newWidth) / 2);
        int displayGuiY = (int)Math.round((double)(displayHeight - newHeight) / 2);

        GL11.glPushMatrix();
        GL11.glScissor(displayGuiX, displayGuiY + 54 * ratioHeight , newWidth, (int) (newHeight - 91 * ratioHeight));
        GL11.glEnable(GL11.GL_SCISSOR_TEST);
        for (int i = 0; i < cells.size(); i++) {
            //GL11.glColor4d(0.1, 0.6, 0.96, 0.95);
            //GL11.glTranslated(0,0, 1);
            int pos_x = guiX + 13;
            int pos_y = guiY + 37 + (i * (cell_height + gap_y)) + scroll_y ;
            drawRect(pos_x, pos_y, pos_x + cell_width, pos_y + cell_height, 0xffffffff);

            drawLimited(fontRendererObj, "Cell #" + cells.get(i).getId(), pos_x, pos_y, cell_width / 2, cell_height, 0xff000000);
        }
        //drawRect(0, 0, this.width, this.height, 0x60ffffff);
        GL11.glDisable(GL11.GL_SCISSOR_TEST);
        GL11.glPopMatrix();

        if (cells.size() > 6) {
            int scrollbar_x = guiX + 90;
            int all_cells = cells.size() * (cell_height + gap_y);
            int cells_visible = 6 * (cell_height + gap_y);
            int scrollable_cells = all_cells - cells_visible;
            int max_height = 71;
            int scrollbar_add = -((scroll_y * max_height) / scrollable_cells);
            int scrollbar_y = (int) (guiY + 38 + scrollbar_add); // 98 - 163
            drawRect(scrollbar_x, scrollbar_y, scrollbar_x + 6, scrollbar_y + 6, 0xff000000);
        }


        super.drawScreen(mouse_x, mouse_y, ticks);
    }

    @Override
    public void initGui() {

        if (cells == null) {
            Minecraft.getMinecraft().displayGuiScreen(null);
            Minecraft.getMinecraft().thePlayer.addChatComponentMessage(new ChatComponentText(EnumChatFormatting.RED + "Error null cells"));
            return;
        }

        int guiX = (width - guiWidth) / 2;
        int guiY = (height - guiHeight) / 2;

        buttonList.clear();

        for (int i = 0; i < cells.size(); i++) {
            //GL11.glColor4d(0.1, 0.6, 0.96, 0.95);
            //GL11.glTranslated(0,0, 1);
            int pos_x = guiX + 13;
            int pos_y = guiY + 37 + (i * (cell_height + gap_y)) + scroll_y ;
            drawRect(pos_x, pos_y, pos_x + cell_width, pos_y + cell_height, 0xffffffff);

            drawLimited(fontRendererObj, "Cell #" + cells.get(i).getId(), pos_x, pos_y, cell_width / 2, cell_height, 0xff000000);
        }

        for (int i = 0 ; i < cells.size(); i++) {
            int pos_x = guiX + 13;
            int pos_y = guiY + 37 + (i * (cell_height + gap_y)) + scroll_y ;
            buttonList.add(cells_buttons[i] = new GuiButtonJailManager(-(i + 1), pos_x, pos_y, pos_x + cell_width, pos_y + cell_height));
        }

        //buttonList.add(buttonClose = new CyborgSoftwareGuiButton(1, guiX + 4, guiY - 3, 7, 7));


        super.initGui();
    }

    @Override
    protected void actionPerformed(GuiButton button) {
        switch (button.id) {
            case 0:
                break;
        }
        super.actionPerformed(button);
    }

    @Override
    protected void mouseClicked(int x, int y, int btn) {
        super.mouseClicked(x, y, btn);
    }

    @Override
    public void handleMouseInput() {
        super.handleMouseInput();

        if (cells.size() <= 6)
            return;

        int dWheel = Mouse.getEventDWheel();

        //System.out.println(dWheel);
        if (dWheel != 0) {
            if (dWheel > 0) {
                scroll_y += 5;
                scroll_y = Math.min(1, scroll_y);
                //System.out.println("Molette vers le haut");
            } else {
                scroll_y -= 5;
                scroll_y = Math.max(-((cells.size() - 6) * (cell_height)), scroll_y);
                //System.out.println("Molette vers le bas");
            }
        }
    }

    @Override
    public void updateScreen() {
        super.updateScreen();
    }
}