package gp_dbc.items;

import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import gp_dbc.Main;
import gp_dbc.config.ConfigManager;
import gp_dbc.network.client.NetworkJailManagerC;
import gp_dbc.proxy.CommonProxy;
import gp_dbc.system.Cell;
import gp_dbc.utils.Data;
import gp_dbc.utils.RayTrace;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.*;
import net.minecraft.world.World;

import java.util.List;

import static gp_dbc.Main.gp;
import static gp_dbc.config.ConfigManager.*;
import static net.minecraft.util.StatCollector.translateToLocal;

public class ItemJailManager extends Item {

    public ItemJailManager()
    {
        super();
        setUnlocalizedName(Main.MODID +".jail_manager");
        GameRegistry.registerItem(this, getUnlocalizedName());
        setCreativeTab(Main.tabGP);
        setTextureName(Main.MODID + ":jail_manager");
        setMaxStackSize(1);
    }

    @Override
    @SideOnly(Side.SERVER)
    public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer player) {
        if (player.isSneaking()) {
            MovingObjectPosition trace = RayTrace.rayTraceServer(player, 5);
            if (trace != null && trace.typeOfHit == MovingObjectPosition.MovingObjectType.BLOCK) {
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + "x: " + trace.blockX + " y: " + trace.blockY + " z: " + trace.blockZ));
                if (gp.jail.addCell(trace.blockX, trace.blockY, trace.blockZ, player.dimension))
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.add_cell")));
                else
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + translateToLocal("error.add_cell")));
            }
        }
        else {
            String cells = "";
            for (Cell cell : gp.jail.getCells())
                cells += cell.toString() + "#";

            CommonProxy.network.sendTo(new NetworkJailManagerC("open~" + cells), (EntityPlayerMP) player);
        }
            // gui manage jail cells

        return itemStack;
    }

    @SideOnly(Side.CLIENT)
    public void addInformation(ItemStack par1ItemStack, EntityPlayer par2EntityPlayer, List par3List, boolean par4) {
        par3List.add("Sneaking Right Click to place a jail cell");
        par3List.add("Right Click to manage jail cells");
    }
}
