package gp_dbc.network.client;

import cpw.mods.fml.common.network.ByteBufUtils;
import cpw.mods.fml.common.network.simpleimpl.IMessage;
import cpw.mods.fml.common.network.simpleimpl.IMessageHandler;
import cpw.mods.fml.common.network.simpleimpl.MessageContext;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import gp_dbc.gui.GuiHandcuffed;
import io.netty.buffer.ByteBuf;

public class NetworkHandcuffedC implements IMessage {

    private String toSend;

    public NetworkHandcuffedC() {
    }

    public NetworkHandcuffedC(String toSend) {
        this.toSend = toSend;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeUTF8String(buf, toSend);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        toSend = ByteBufUtils.readUTF8String(buf);
    }

    public static class MyMessageHandlerC implements
            IMessageHandler<NetworkHandcuffedC, IMessage> {

        @SideOnly(Side.CLIENT)
        @Override
        public IMessage onMessage(NetworkHandcuffedC message,
                                  MessageContext ctx) {

            String[] split = message.toSend.split("~");
            String key = split[0];

            if (key.equals("start")) {
                try {
                    GuiHandcuffed.startTime = Long.parseLong(split[1]);
                    GuiHandcuffed.timeToWait = Long.parseLong(split[2]);
                } catch (Exception e) {
                }

                GuiHandcuffed.handcuffed = true;
            }
            else if (key.equals("end"))
                GuiHandcuffed.handcuffed = false;

            return null;
        }
    }
}
