package gp_dbc.system;

import JinRyuu.JRMCore.server.JGPlayerMP;
import gp_dbc.utils.Data;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;

import java.util.List;
import java.util.UUID;

import static gp_dbc.config.ConfigManager.*;
import static net.minecraft.util.StatCollector.translateToLocal;

public class GalacticPatrol {

    private List<UUID> patrolmans;
    public Jail jail;

    public GalacticPatrol() {
        patrolmans = Data.loadDataUUID("galactic_patrols");
        jail = new Jail();
    }

    public int addToGalaticPatrol(EntityPlayer player) {
        return addToGalaticPatrol(player, false);
    }

    public int addToGalaticPatrol(EntityPlayer player, boolean chatError) {
        return addToGalaticPatrol((EntityPlayerMP)player, chatError);
    }

    public int addToGalaticPatrol(EntityPlayerMP player) {
        return addToGalaticPatrol(player, false);
    }

    public int addToGalaticPatrol(EntityPlayerMP player, boolean chatError) {

        JGPlayerMP jgPlayer = new JGPlayerMP(player);
        jgPlayer.connectBaseNBT();
        int align = jgPlayer.getAlignment();


        if (align < MIN_ALIGN_TO_JOIN) {
            if (chatError)
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + translateToLocal("error.min_align_to_join")));
            return 2;
        }
        else if (align > MAX_ALIGN_TO_JOIN) {
            if (chatError)
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + translateToLocal("error.max_align_to_join")));
            return 3;
        }

        if (!patrolmans.contains(player.getUniqueID())) {
            patrolmans.add(player.getUniqueID());
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.join_galactic_patrol")));
        }
        else
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + translateToLocal("error.join_galactic_patrol")));

        Data.saveDataUUID(patrolmans, "galactic_patrols");

        return 0;
    }

    private void addForceToGalacticPatrol(UUID uuid) {
        patrolmans.add(uuid);
        Data.saveDataUUID(patrolmans, "galactic_patrols");
    }

    public boolean removeFromGalaticPatrol(EntityPlayer player) {
        return removeFromGalaticPatrol(player, false);
    }

    public boolean removeFromGalaticPatrol(EntityPlayer player, boolean chatError) {
        return removeFromGalaticPatrol((EntityPlayerMP)player, chatError);
    }

    public boolean removeFromGalaticPatrol(EntityPlayerMP player) {
        return removeFromGalaticPatrol(player, false);
    }

    public boolean removeFromGalaticPatrol(EntityPlayerMP player, boolean chatError) {

        boolean removed = patrolmans.remove(player.getUniqueID());
        Data.saveDataUUID(patrolmans, "galactic_patrols");

        if (removed)
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.leave_galactic_patrol")));
        else
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + translateToLocal("error.leave_galactic_patrol")));

        return removed;
    }

    public boolean isInGalacticPatrol(EntityPlayer player) {
        return patrolmans.contains(player.getUniqueID());
    }

    public boolean isInGalacticPatrol(EntityPlayerMP player) {
        return patrolmans.contains(player.getUniqueID());
    }

    public boolean isInGalacticPatrol(UUID uuid) {
        return patrolmans.contains(uuid);
    }

    public List<UUID> getPatrolmans() { return patrolmans; }
}
