package gp_dbc.system;

import JinRyuu.JRMCore.server.JGPlayerMP;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.PlayerEvent;
import cpw.mods.fml.common.gameevent.TickEvent;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import gp_dbc.Main;
import gp_dbc.network.client.NetworkHandcuffedC;
import gp_dbc.proxy.CommonProxy;
import gp_dbc.utils.TextUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.UUID;

import static gp_dbc.Main.gp;
import static gp_dbc.config.ConfigManager.*;
import static gp_dbc.utils.PlayerUtils.getPlayerFromUUID;
import static net.minecraft.util.StatCollector.translateToLocal;

public class Handcuff {

    // patrol~handcuffed|StartTimeHandcuffed
    @SideOnly(Side.SERVER)
    public static HashMap<String, Long> handcuffed = new HashMap<>();

    int tick = 0;
    final int SLOWTICK_MAX = 20;//2000;

    @SideOnly(Side.SERVER)
    @SubscribeEvent
    public void checkTimeJailer(TickEvent.ServerTickEvent event) {
        if (handcuffed.isEmpty())
            return;

        if (tick >= SLOWTICK_MAX) {
            tick = 0;

            Iterator<Map.Entry<String, Long>> iterator = handcuffed.entrySet().iterator();
            while (iterator.hasNext()) {
                Map.Entry<String, Long> entry = iterator.next();
                UUID uuid_patrol = UUID.fromString(entry.getKey().split("~")[0]);
                UUID uuid_inmate = UUID.fromString(entry.getKey().split("~")[1]);
                long time_start = entry.getValue();
                long time_left = (time_start + (TIME_TO_GO_IN_JAIL * 1000) - System.currentTimeMillis()) / 1000;

                if (time_left <= 0) {
                    EntityPlayer inmate = getPlayerFromUUID(uuid_inmate);
                    if (inmate != null) {
                        CommonProxy.network.sendTo(new NetworkHandcuffedC("end~"), (EntityPlayerMP) inmate);

                        JGPlayerMP jgInmate = new JGPlayerMP(inmate);
                        NBTTagCompound nbt = jgInmate.connectBaseNBT();
                        nbt.setInteger("jrmcHar4va", 0);

                        iterator.remove();

                        EntityPlayer patrol = getPlayerFromUUID(uuid_patrol);
                        gp.jail.putPlayerInJail(patrol, inmate, 20, patrol != null);
                    }
                    else
                        entry.setValue(-1L);
                }

            }
        }
        else
            tick++;
    }

    @SubscribeEvent
    public void LogInCheckKOHandcuff(PlayerEvent.PlayerLoggedInEvent event) {
        EntityPlayer inmate = event.player;
        JGPlayerMP jgInmate = new JGPlayerMP(inmate);
        NBTTagCompound nbt = jgInmate.connectBaseNBT();
        if (getTimeHandcuffed(inmate) == -1) {
            nbt.setInteger("jrmcHar4va", 0);
            handcuffed.remove(getHandcuffed(inmate));
        }
    }

    @SideOnly(Side.SERVER)
    public static boolean putHandcuff(EntityPlayer jailer, EntityPlayer inmate) {
        /*if (handcuffeds.get(inmate.getUniqueID()) != null) {
            jailer.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ERROR_ALREADY_HANDCUFFED));
            return false;
        }*/
        long current_time = System.currentTimeMillis();

        handcuffed.put(jailer.getUniqueID() + "~" + inmate.getUniqueID(), current_time);
        jailer.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + translateToLocal("success.you_handcuffed_him")));


        String[] texts = TextUtils.getSeparateText(translateToLocal("success.you_are_handcuffed"), "%%");
        inmate.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + texts[0] + TIME_TO_GO_IN_JAIL + texts[1]));

        JGPlayerMP jgInmate = new JGPlayerMP(inmate);
        NBTTagCompound nbt = jgInmate.connectBaseNBT();
        nbt.setInteger("jrmcHar4va", Integer.MAX_VALUE);

        CommonProxy.network.sendTo(new NetworkHandcuffedC("start~" + current_time + "~" + TIME_TO_GO_IN_JAIL), (EntityPlayerMP) inmate);

        return true;
    }

    @SideOnly(Side.SERVER)
    public static String getHandcuffed(EntityPlayer inmate) {
        for (String uuids : handcuffed.keySet()) {
            String[] split = uuids.split("~");
            if (split[1].equals(inmate.getUniqueID().toString()))
                return uuids;
        }
        return null;
    }

    @SideOnly(Side.SERVER)
    public static long getTimeHandcuffed(EntityPlayer inmate) {
        String uuids = getHandcuffed(inmate);
        if (uuids == null)
            return 0;
        return handcuffed.get(uuids);
    }

    @SideOnly(Side.SERVER)
    public static boolean isHandcuffed(EntityPlayer inmate) {
        return getHandcuffed(inmate) != null;
    }
}
